;Program pro napr. melodicky zvonek   strednik uvozuje komentare
;generator frekvence , pocet v mikrosec procedury zpozdi 3*L2*(L1+1)
;                                8Vss-,GP0,1,2,; 1Vdd+,GP5,4,3 
;delky zpozdeni - odpovidaji pro 4Mhz oscilator - zde interni 
;509 ma jen dvou urovnovy HW zasobnik  vychazi z tony.asm
processor 12f509  ; !!!!!!!!!!!! pokud pouzijete 508 tak zmente
;list p=12f509, f=inhx8m,R=HEX  ;Enter device name  
INCLUDE "p12f509.inc"  ; !!!!!!!!!!!! pokud pouzijete 508 tak zmente
;priklady nastaveni config bitu - viz dokumentace 
;__config _ExtRC_OSC & _CP_ON & _WDT_OFF & _MCLRE_ON 
;__config _IntRC_OSC & _CP_OFF & _WDT_OFF & _MCLRE_OFF
;nastavi  mj interni oscilator _IntRC_OSC , 
__config _IntRC_OSC & _CP_OFF & _WDT_OFF & _MCLRE_ON
;nasleduje definice promennych a konstant
RAM		equ	0C		;zacatek RAM (offset) 
L1		EQU	RAM		;pocet vnitrniho cyklu(1)
L2		EQU	RAM+1	;pocet vnejsiho  cyklu(2)
P1		EQU	RAM+2	;pomocna v zpozdim	
P2		EQU	RAM+3	;pomocna v zpozdim	
L3		EQU	RAM+4	;pocet vnejsiho  cyklu(3)
P3		EQU	RAM+5	;pomocna v zpozdim	
cTl1	EQU	b'00000001' ; indikace jednoho tl
cTl2	EQU	b'00000010' ; indikace dvou tl
cObe	EQU	b'00000011' ; indikace obou tl
Delka	EQU	RAM+6	;delka generovani tonu  
VSTUP   EQU GPIO ; kam je umisten vstup tl - napr  EQU RAM+15
#define	Repro	GPIO,5 ;vystupni port
#define	PwrS	GPIO,4 ; pro pridrzny  kontakt - aktivni v -
#define	Led		GPIO,2 ; signalizace - {zapnuti,blikanim-chyba-napr. trvale sepnuta tlacitka   
#define	Test	GPIO,3 ; pro testovani - nevyuzito 
#define	Tl1		GPIO,0 ; tlacitko 1
#define	Tl2		GPIO,1 ; tlacitko 2
		   org 0  ;urcuje od jake adresy bude nasledujici usek nahran 
		goto	start  ; od teto adresy zacne program bezet i po resetu 
		   org 10 ;adresy od 0 do N dle typu MC vyhrazeny pro tzv. peruseni
zpozdim	MOVF	L3,W  ;(3) procedura pro zpozdeni   v sec 
		MOVWF 	P3
zpozdi 	MOVF	L2,W  ; (2) v milisec
		MOVWF 	P2
Z2	 	MOVF	L1,W  ; (1)
		MOVWF 	P1
Z1	 	DECFSZ	P1,F
		GOTO 	Z1
		DECFSZ 	P2,F
		GOTO 	Z2
		DECFSZ 	P3,F
		GOTO 	zpozdi
		retlw 	0  ;navrat z procedur 
NASTAV ; ********** NASTAVeni MC po startu *********
		movlw 	b'00000000';6-0 weakPullUp(str22)-outLED,1p pres R na+
		option    ;7-0 povoleni probuzeni - wake up ena
		movlw 	b'11111111' ; definuj vsechny piny jako vstup
		tris 	GPIO	 
		clrf 	GPIO
		bsf     PwrS  ; nastav na jednicku, tj. kladne napeti
		retlw 	0
VYSTUPY; ********** NASTAV *********
		movlw 	b'11001011'
		tris 	GPIO	; fce pinu 0 vystup  1 vstup
		bcf		PwrS    ;sepne PNP tranzistor 
		retlw 	0
; ***************************** START*************
start  
;		movlw 	OSCCAL ; kalibrace oscilatoru
		call 	s300 ;volani procedury-nastavZpozdeni na 300 ms
		call 	zpozdim  ; volani smycky pro zpozdeni
		call 	NASTAV ;
		movfw 	VSTUP  ;  
		andlw 	cObe  ; zacina kontrola stavu tlacitek  
		xorlw   cObe
		btfsc	STATUS,Z
		goto 	Zadne  ; neni stlaceno zadne
		call 	s300   ; zacatek kontroly stavu tlacitek po 300ms 
		call 	zpozdim ; 
		movfw 	VSTUP
		andlw 	cObe
		;iorlw   cObe
		btfss	STATUS,Z ;vysledek=0 pak z=1
		goto 	Jedno  
		goto	lObe 
Jedno	movfw 	VSTUP  ; bylo stlaceno jen jedno
		andlw 	cTl1
		;xorlw   cTl1
		btfsc	STATUS,Z
		goto 	lTl1    ; bylo to Tl1
		movfw 	VSTUP
		andlw 	cTl2
		;xorlw   cTl2
		btfsc	STATUS,Z
		goto    lTl2    ; bylo to Tl2
		goto 	Zadne
;nasleduje usek pro prehrani melodie zavisle na kombinaci Tl
lTl1	call 	VYSTUPY 
		bsf 	Led  ; rozsviceni Led 
		goto    lP1	 ; skok na navesti (radek s lP1) prehrani melodie  
		goto    lSpi
lTl2	call 	VYSTUPY
		bsf 	Led
		goto    lP2	
		goto    lSpi ;radek zde zustal po uprave-nemusi byt
lObe	call 	VYSTUPY
		bsf 	Led
		goto    lP3	
		goto    lSpi
lSpi	call	m01  ; melodie dohrana
		call 	zpozdim	;  300msec
;kontrola jestli je jeste  stlaceno , pokud ano tak tl  blikej 
lKonTl	movfw 	VSTUP
		andlw 	cObe  ;alespon jedna 
		xorlw   cObe
		btfsc	STATUS,Z
		goto 	Zadne  ;neni zadne seple skoc na navesti Zadne
		call 	Blik
 		goto 	lKonTl
Zadne   bsf		PwrS  ;vypni vsechny vystupy
		bcf		Repro
		bcf 	Led
		call    NASTAV
		sleep   ; pokud nebude zapojen pridrzny kontakt pak zde MCceka
				; dokud bude pritomno U nebo na jinou aktivitu
		goto    start
Blik	bsf		Led  ; procedura pro "blikani" - 
		call 	s300
		call 	zpozdim
		bcf		Led
		call 	zpozdim
		retlw 	' '
;--------------------------------------------------------
m01		call 	s300 ;proc nastaveni parametru pro zpozdeni 1s
		movlw 	d'3'
		movwf 	L3
		retlw 	' '	
s300	movlw	d'255' ;proc nastaveni parametru pro zpozdeni 300ms
		movwf	L2
		movlw	d'255'
		movwf	L1
		movlw 	d'1'
		movwf 	L3
		retlw 	' '
lP1		call	C1  ;prehraje tyto tony
		call	hrej
; zde mohou nasledovat dalsi  napr. call D1 call hrej atd
		call	D1
		call	hrej
		call	E1
		call	hrej
		call	F1
		call	hrej
		call	G1
		call	hrej
		call	A1
		call	hrej
		call	H1
		call	hrej
		call	C2
		call	hrej
		goto  	lSpi
lP2		call	C2
		call	hrej
		call	H1
		call	hrej
		call	A1
		call	hrej
		call	G1
		call	hrej
		call	F1
		call	hrej
		call	E1
		call	hrej
		call	D1
		call	hrej
		call	C1
		call	hrej
		goto  	lSpi
lP3		call	C1
		call	hrej
		call	C2
		call	hrej
		call	C1
		call	hrej
		call	C2
		call	hrej
		call	C1
		call	hrej
		call	C2
		call	hrej
		call	C1
		call	hrej
		call	C2
		call	hrej
		goto  	lSpi
hrej	bsf		Repro  ; 
		call 	zpozdim
		bcf		Repro
		call 	zpozdim
		DECFSZ 	Delka,F  ; hraje ton definovanou delku
		goto 	hrej
		retlw 	0
;--------------- definice tonu jedne oktavy 
C1		movlw   d'126'  ;nastavena tak, aby vsechny tony byly
		movwf	Delka   ; stejne dlouhe 
		movlw	d'3'
		movwf	L2      ; L2,L1 urcuji vysku tonu
		movlw	d'213'
		movwf	L1
		retlw 	' '
;nasleduje definice dalsich tonu D1,E1,F1,G1,A1,H1,C2
D1		movlw   d'142'
		movwf	Delka
		movlw	d'3'
		movwf	L2
		movlw	d'188'
		movwf	L1
		retlw 	' '
E1		movlw   d'160'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'251'
		movwf	L1
		retlw 	' '
F1		movlw   d'170'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'238'
		movwf	L1
		retlw 	' '
G1		movlw   d'190'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'217'
		movwf	L1
		retlw 	' '
A1		movlw   d'214'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'188'
		movwf	L1
		retlw 	' '
H1		movlw   d'242'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'169'
		movwf	L1
		retlw 	' '
C2		movlw   d'255'
		movwf	Delka
		movlw	d'2'
		movwf	L2
		movlw	d'159'
		movwf	L1
		retlw 	' '
 END  ; musi byt mezera - jinak prekladac error
